;()  ,  2010
CT		.equ	0h
PNT		.equ	1C00h
PGT		.equ	2000h

		di
		lxi	sp,0F000h
		mvi	a,11111100b	;---
		out	80h
		lxi	h,3FFFh
cls:
		mvi	m,0
		dcx	h
		mov	a,h
		ora	a
		jp	cls

		lxi	h,0E000h
		xra	a
clrram:
		mov	m,a
		inx	h
		cmp	h
		jnz	clrram

		xra	a
		out	88h
		out	89h

		in	84h
		ani	00000110b
		ori	00010000b
					;  VRAM - 0000h-3FFFh
					;  SCR2
		out	84h
		mvi	a,7	; PNT  VRAM - 1C00h
		out	91h 
		mvi	a,0	;CT    0000h  VRAM
		out	92h
		mvi	a,8	;PGT    2000h  VRAM
		out	93h

		mvi	a,13
		mvi	e,0
AYOFF1:
		call	WRTPSG
		dcr	a
		jp	AYOFF1

DrwLogo:
		lxi	h,PNT+300h+3
		lxi	d,32
		mvi	a,1
		mvi	c,26
SetPNTloop:		
		push	h
		mov m,a\ dad d\ inr a
		mov m,a\ dad d\ inr a
		mov m,a\ inr a
		pop	h
		inx	h
		dcr	c
		jnz	SetPNTloop
		lxi	h,PGT+1800h+8+5
		lxi	d,Logo+14
		mvi	c,26
SetPGTloop2:
		mvi	b,15
SetPGTloop1:
		ldax	d
		dcx	d
		mov	m,a
		inx	h
		dcr	b
		jnz	SetPGTloop1
		mvi	a,30
		add	e
		mov	e,a
		mvi	a,0
		adc	d
		mov	d,a
		mvi	a,24-15
		add	l
		mov	l,a
		mvi	a,0
		adc	h
		mov	h,a
		dcr	c
		jnz	SetPGTloop2

		lxi	h,CT+1800h
		lxi	b,400h
SetCTloop:
		mvi	m,0F0h
		inx	h
		dcx	b
		mov	a,b
		ora	c
		jnz	SetCTloop

		mvi	a,1101b
		out	87h

		jmp	L4010

FILVRM:
L0056:
		push	h
		push	psw
FILVRMloop:
		pop	psw
		mov	m,a
		push	psw
		inx	h
		dcx	b
		mov	a,c
		ora	b
		jnz	FILVRMloop
		pop	psw
		pop	h
		ret

LDIRVM:
L005C:
		xchg
		push	h
LDIRVMloop:
		ldax	d
		mov	m,a
		inx	h
		inx	d
		dcx	b
		mov	a,c
		ora	b
		jnz	LDIRVMloop
		pop	h
		ret

		.include "VI53.asm"

SNSMAT:
		push    b
		ani     0Fh
		mov     b, a
		in      82h
		ani     0F0h
		ora     b
		out     82h
		in      81h
		pop     b
		ret

GTSTCK:
L00D5:
		dcr     a
		jm      GTSTCK3
		in      8Ch
		jz      GTSTCK1
		in      8Dh
GTSTCK1:
		lxi     h, JoyDir
		cma
GTSTCK2:
		ani     00001111b
		mov     e, a
		mvi     d, 0
		dad     d
		mov     a, m
		ret
GTSTCK3:
		mvi     a, 8
		call    SNSMAT
		rrc
		rrc
		rrc
		rrc
		lxi     h, KeybDir
		jmp     GTSTCK2
KeybDir:
		.db    0,   3,   5,   4
		.db    1,   2,   0,   3
		.db    7,   0,   6,   5
		.db    8,   1,   7,   0
JoyDir:
		.db    0,   5,   1,   0
		.db    3,   4,   2,   3
		.db    7,   6,   8,   7
		.db    0,   5,   1,   0

GTTRIG:
L00D8:
		dcr     a
		jm      GTTRIG3
		push    psw
		cpi     2
		in      8Dh
		jnc     GTTRIG1
		in      8Ch
GTTRIG1:
		mov     b, a
		pop     psw
		ani     1
		mvi     a, 10h
		jz      GTTRIG2
		rlc
GTTRIG2:
		ana     b
		cma
		rz
		xra	a
		ret
GTTRIG3:
		mvi     a, 8
		call    SNSMAT
		cma
		ani     1
		rz
		mvi	a,0FFh
		ret


CHGSND:
L0135:
		ana	a
		in	82h
		jz	snd0
		ori	10000000b
		out	82h
		ret
snd0:
		ani	01111111b
		out	82h
		ret

